#!/usr/bin/env perl

%LAKARA = (
"लट्" => "वर्तमानः",
"लङ्" => "अनद्यतनभूतः",
"लुङ्" => "सामान्यभूतः",
"लिट्" => "परोक्षभूतः",
"लुट्" => "अनद्यतनभविष्यकालः",
"लृट्" => "सामान्यभविष्यकालः",
"लोट्" => "आज्ञाप्रार्थनादिषु",
"विधिलिङ्" => "विधिः",
"आशीर्लिङ्" => "आशीः",
"लृङ्" => "क्रियानिष्पत्तौ-हेतुमद्भावे-च",
"शतृ_लट्" => "वर्तमानसमानकालः",
"शानच्_लट्_कर्तरि" => "वर्तमानसमानकालः-कर्तरि",
"शानच्_लट्_कर्मणि" => "वर्तमानसमानकालः-कर्मणि",
"क्त" => "भूतकर्म",
"क्तवतु" => "भूतकर्ता",
"शतृ_लृट्" => "भविष्यत्समानकालः",
"शानच्_लृट्_कर्तरि "=> "भविष्यत्समानकालः-कर्तरि",
"शानच्_लृट्_कर्मणि "=> "भविष्यत्समानकालः-कर्मणि",
"तुमुन्" => "प्रयोजनम्",
"ल्युट्" => "भावः"
);

%AKARMAKA = (
"अब्1" => 1,
"आङ्_या1" => 1,
"अग्1" => 1,
"अघ्1" => 1,
"अम्भ्1" => 1,
"अन्1" => 1,
"अण्1" => 1,
"अण्2" => 1,
"आस्1" => 1,
"अस्2" => 1,
"अत्2" => 1,
"भा1" => 1,
"बाड्1" => 1,
"बह्1" => 1,
"बाह्1" => 1,
"बल्1" => 1,
"भाम्1" => 1,
"भाम1" => 1,
"बण्1" => 1,
"भष्1" => 1,
"बस्1" => 1,
"भास्1" => 1,
"बद्1" => 1,
"भद्1" => 1,
"भेष्1" => 1,
"भी1" => 1,
"भिन्द्1" => 1,
"बिद्1" => 1,
"भ्लाश्1" => 1,
"भ्लेष्1" => 1,
"भृड्1" => 1,
"बृह्1" => 1,
"बृह्2" => 1,
"बृंह्1" => 1,
"भृश्1" => 1,
"भ्राज्1" => 1,
"भ्राज्2" => 1,
"भ्रम्1" => 1,
"भ्रम्2" => 1,
"भ्रंस्1" => 1,
"भ्रण्1" => 1,
"भ्रन्श्1" => 1,
"भ्रन्श्2" => 1,
"भ्रश्1" => 1,
"भ्राश्1" => 1,
"भ्रेज्1" => 1,
"भ्रेष्1" => 1,
"भ्री1" => 1,
"भू1" => 1,
"बुक्क्2" => 1,
"भूष्2" => 1,
"भ्यस्1" => 1,
"चड्1" => 1,
"चह्1" => 1,
"चह्2" => 1,
"चक्2" => 1,
"चकास्1" => 1,
"चल्1" => 1,
"चल्2" => 1,
"चल1" => 1,
"छर्द्1" => 1,
"छद्1" => 1,
"चेल्1" => 1,
"चेष्ट्1" => 1,
"चीभ्1" => 1,
"चिल्ल्1" => 1,
"चिट्1" => 1,
"चित्1" => 1,
"चुच्य्1" => 1,
"चुड्1" => 1,
"चुड्ड्1" => 1,
"चुक्क्1" => 1,
"चुल्ल्1" => 1,
"चुप्1" => 1,
"चुत्ट्1" => 1,
"डी1" => 1,
"एज्1" => 1,
"एज्2" => 1,
"एध्1" => 1,
"ङु1" => 1,
"गड्2" => 1,
"घघ्1" => 1,
"गज्1" => 1,
"गज्2" => 1,
"गज्3" => 1,
"गल्2" => 1,
"गल्भ्1" => 1,
"गन्ध्1" => 1,
"गर्ज्1" => 1,
"गर्व्1" => 1,
"गर्व1" => 1,
"गर्द्1" => 1,
"घट्1" => 1,
"घत्ट्1" => 1,
"घत्ट्2" => 1,
"गदी1" => 1,
"गेप्1" => 1,
"ग्लै1" => 1,
"गोष्ट्1" => 1,
"घृ2" => 1,
"गॄ3" => 1,
"गृज्1" => 1,
"गृज्2" => 1,
"घृण्1" => 1,
"ग्रथ्1" => 1,
"ग्रु1" => 1,
"घ्रु1" => 1,
"गु1" => 1,
"घु1" => 1,
"गु2" => 1,
"गुज्1" => 1,
"गुज्2" => 1,
"गुप्3" => 1,
"गुर्1" => 1,
"घुर्1" => 1,
"घुष्2" => 1,
"गुर्व्1" => 1,
"गुर्द्1" => 1,
"गुर्द्2" => 1,
"घुट्1" => 1,
"गुद्1" => 1,
"गुध्2" => 1,
"हस्2" => 1,
"हट्1" => 1,
"हठ्1" => 1,
"हद्1" => 1,
"हेष्1" => 1,
"हेठ्2" => 1,
"हिक्क्1" => 1,
"ह्लस्1" => 1,
"ह्लाद्1" => 1,
"ह्मल्1" => 1,
"हृष्2" => 1,
"ह्रष्1" => 1,
"ह्रस्1" => 1,
"ह्राद्1" => 1,
"ह्रेष्1" => 1,
"ह्री1" => 1,
"ह्रीछ्1" => 1,
"हुड्1" => 1,
"हुर्छ्1" => 1,
"ह्वल्1" => 1,
"ह्वृ1" => 1,
"ईह्1" => 1,
"इन्ध्1" => 1,
"ईर्क्ष्य्1" => 1,
"ईर्ष्य्1" => 1,
"ईश्1" => 1,
"इद्1" => 1,
"जभ्1" => 1,
"जागृ1" => 1,
"जज्1" => 1,
"जज्2" => 1,
"जल्2" => 1,
"जन्2" => 1,
"जट्1" => 1,
"झट्1" => 1,
"जै1" => 1,
"जेह्1" => 1,
"जीव्1" => 1,
"जॄ2" => 1,
"जॄ3" => 1,
"जृभ्1" => 1,
"ज्रि2" => 1,
"जुत्1" => 1,
"ज्वर्1" => 1,
"कब्1" => 1,
"खच्1" => 1,
"कड्1" => 1,
"कड्2" => 1,
"खज्2" => 1,
"कक्1" => 1,
"कख्1" => 1,
"कल्1" => 1,
"कल्ल्1" => 1,
"कन्1" => 1,
"कण्1" => 1,
"कण्ड्2" => 1,
"कप्1" => 1,
"कर्व्1" => 1,
"खर्व्1" => 1,
"कर्द्1" => 1,
"काश्1" => 1,
"काश्2" => 1,
"कठ्1" => 1,
"कठ्2" => 1,
"खव्1" => 1,
"कत्र1" => 1,
"कद्2" => 1,
"कै1" => 1,
"खेल्1" => 1,
"केप्1" => 1,
"किल्1" => 1,
"किट्1" => 1,
"खिट्1" => 1,
"खिद्1" => 1,
"खिद्3" => 1,
"क्लम्1" => 1,
"क्लद्1" => 1,
"क्लीब्1" => 1,
"क्लिद्1" => 1,
"क्मर्1" => 1,
"क्नू1" => 1,
"खोल्1" => 1,
"खोर्1" => 1,
"कृड्1" => 1,
"कृप्1" => 1,
"कृप1" => 1,
"क्षर्1" => 1,
"क्रद्1" => 1,
"क्षै1" => 1,
"क्षि1" => 1,
"क्षि3" => 1,
"क्षीब्1" => 1,
"क्रीड्1" => 1,
"क्षीज्1" => 1,
"क्रु1" => 1,
"क्षु1" => 1,
"ख्रु1" => 1,
"क्षुभ्1" => 1,
"क्षुभ्2" => 1,
"क्षुभ्3" => 1,
"क्रुन्च्1" => 1,
"क्रुध्1" => 1,
"क्षुध्1" => 1,
"क्ष्वेल्1" => 1,
"क्ष्विद्2" => 1,
"कु1" => 1,
"कू1" => 1,
"खु1" => 1,
"कु2" => 1,
"कुच्1" => 1,
"कुड्2" => 1,
"कुड्3" => 1,
"कूज्1" => 1,
"कुल्1" => 1,
"कुमार1" => 1,
"कुम्भ्1" => 1,
"कुण्1" => 1,
"कुन्च्1" => 1,
"कुप्1" => 1,
"कुर्1" => 1,
"कुर्द्1" => 1,
"खुर्द्1" => 1,
"कुस्म्1" => 1,
"कुट्1" => 1,
"कुठ्1" => 1,
"कूट1" => 1,
"कुथ्2" => 1,
"क्वण्1" => 1,
"क्वथ्1" => 1,
"लब्1" => 1,
"लड्1" => 1,
"लाघ्1" => 1,
"लग्2" => 1,
"लज्3" => 1,
"लस्2" => 1,
"लस्ज्1" => 1,
"लट्1" => 1,
"लिश्1" => 1,
"लोड्1" => 1,
"लोष्ट्1" => 1,
"लुड्2" => 1,
"लुण्ठ्1" => 1,
"लुट्2" => 1,
"लुठ्2" => 1,
"मघ्1" => 1,
"मह्2" => 1,
"मण्1" => 1,
"मन्3" => 1,
"मर्च्1" => 1,
"मार्ज्1" => 1,
"मस्1" => 1,
"मश्1" => 1,
"मस्ज्1" => 1,
"मठ्1" => 1,
"मद्2" => 1,
"मेध्1" => 1,
"मी1" => 1,
"मील्1" => 1,
"मिष्2" => 1,
"मिश्1" => 1,
"मीव्1" => 1,
"मिथ्1" => 1,
"मिध्1" => 1,
"मिद्3" => 1,
"म्लै1" => 1,
"म्लेछ्1" => 1,
"म्लेछ्2" => 1,
"म्लेट्1" => 1,
"मृक्ष्1" => 1,
"मृध्1" => 1,
"म्रछ्1" => 1,
"म्रक्ष्1" => 1,
"म्रेड्1" => 1,
"मुच्1" => 1,
"मुज्1" => 1,
"मुज्2" => 1,
"मूल्1" => 1,
"मुर्छ्1" => 1,
"मुस्त्1" => 1,
"मूत्र1" => 1,
"मुद्1" => 1,
"नर्द्1" => 1,
"णस्1" => 1,
"णास्1" => 1,
"णट्1" => 1,
"नद्1" => 1,
"णद्1" => 1,
"नि_भृ1" => 1,
"णील्1" => 1,
"निष्_पद्1" => 1,
"णिश्1" => 1,
"णीव्1" => 1,
"णिद्2" => 1,
"नृत्1" => 1,
"फल्1" => 1,
"फल्2" => 1,
"पार1" => 1,
"पर_आङ्_अय्1" => 1,
"परि_आप्1" => 1,
"परि_कॄत्1" => 1,
"पर्ण1" => 1,
"पर्द्1" => 1,
"पत्1" => 1,
"पेस्1" => 1,
"पिड्1" => 1,
"पिज्1" => 1,
"पिट्1" => 1,
"पीव्1" => 1,
"पृ3" => 1,
"पृञ्ज्1" => 1,
"प्र_षद्1" => 1,
"प्र_वृत्1" => 1,
"प्रथ्1" => 1,
"प्रोथ्1" => 1,
"पूल्1" => 1,
"पुल्2" => 1,
"फुल्ल्1" => 1,
"पुण्1" => 1,
"पुष्1" => 1,
"पूष्1" => 1,
"पुष्प्1" => 1,
"पुर्व्1" => 1,
"पुत्ट्1" => 1,
"पूय्1" => 1,
"प्याय्1" => 1,
"प्यै1" => 1,
"ऋछ्1" => 1,
"ऋध्1" => 1,
"ऋध्2" => 1,
"रब्1" => 1,
"रञ्ज्2" => 1,
"रञ्ज्3" => 1,
"राघ्1" => 1,
"रह्1" => 1,
"षह्2" => 1,
"राज्1" => 1,
"षम्1" => 1,
"रम्भ्1" => 1,
"रण्1" => 1,
"रस्1" => 1,
"रास्1" => 1,
"षस्1" => 1,
"षस्त्1" => 1,
"षट्1" => 1,
"षद्1" => 1,
"रै1" => 1,
"रेभ्1" => 1,
"रेष्1" => 1,
"रेव्1" => 1,
"षिध्3" => 1,
"ष्ना1" => 1,
"रोड्1" => 1,
"ष्ठा1" => 1,
"ष्ट्यै1" => 1,
"रु2" => 1,
"रुच्1" => 1,
"षुह्1" => 1,
"रुह्1" => 1,
"रूक्ष1" => 1,
"षुर्1" => 1,
"रुष्2" => 1,
"रुष्3" => 1,
"रुट्1" => 1,
"रुद्1" => 1,
"ष्वप्1" => 1,
"ष्विद्2" => 1,
"ष्तीम्1" => 1,
"ष्तुभ्1" => 1,
"ष्तुच्1" => 1,
"शक्3" => 1,
"शम्1" => 1,
"सम्_अव_ई1" => 1,
"संग्राम्1" => 1,
"संस्त्1" => 1,
"शण्1" => 1,
"सार1" => 1,
"शठ1" => 1,
"सत्र1" => 1,
"साध्1" => 1,
"शद्1" => 1,
"शद्2" => 1,
"श्च्युत्1" => 1,
"सै1" => 1,
"सेक्1" => 1,
"शीङ्1" => 1,
"शिज्1" => 1,
"शील्1" => 1,
"स्खल्1" => 1,
"श्लोण्1" => 1,
"श्मील्1" => 1,
"शोण्1" => 1,
"शौट्1" => 1,
"स्पर्ध्1" => 1,
"स्पद्1" => 1,
"स्फाय्1" => 1,
"स्फुल्1" => 1,
"स्फुर्1" => 1,
"स्फूर्ज्1" => 1,
"स्फुट्1" => 1,
"स्फुट्2" => 1,
"स्फुट्3" => 1,
"सृप्1" => 1,
"शृध्1" => 1,
"शृध्2" => 1,
"श्रम्1" => 1,
"श्रम्भ्1" => 1,
"स्रन्भ्1" => 1,
"स्रन्भ्2" => 1,
"श्रथ्1" => 1,
"श्रथ1" => 1,
"श्रोण्1" => 1,
"शुभ्2" => 1,
"शुच्2" => 1,
"शुच्य्1" => 1,
"शुन्भ्2" => 1,
"शुन्ध्1" => 1,
"शुन्ध्2" => 1,
"शूर्1" => 1,
"सूर्क्ष्य्1" => 1,
"शुठ्3" => 1,
"शुध्1" => 1,
"श्वल्1" => 1,
"श्वल्ल्1" => 1,
"श्वस्1" => 1,
"श्वठ1" => 1,
"श्वि1" => 1,
"श्वित्1" => 1,
"श्विद्1" => 1,
"स्वृ1" => 1,
"स्थल्1" => 1,
"स्तम्1" => 1,
"स्तन्1" => 1,
"स्तन1" => 1,
"स्तेप्1" => 1,
"स्तिम्1" => 1,
"स्तिप्1" => 1,
"स्थूल1" => 1,
"स्त्यै1" => 1,
"स्यम्1" => 1,
"स्यन्द्1" => 1,
"टल्1" => 1,
"टीक्1" => 1,
"ट्म्प्" => 1,
"उ1" => 1,
"उब्ज्1" => 1,
"उप_लक्ष्2" => 1,
"उप_विश्1" => 1,
"ऊर्ज्1" => 1,
"उर्द्1" => 1,
"उठ्2" => 1,
"उत्_पद्1" => 1,
"वाह्1" => 1,
"वक्ष्1" => 1,
"वन्1" => 1,
"वण्1" => 1,
"वर्च्1" => 1,
"वर्ष्1" => 1,
"वाश्1" => 1,
"वस्3" => 1,
"वठ्1" => 1,
"वठ्2" => 1,
"वै1" => 1,
"वेह्1" => 1,
"वेल्1" => 1,
"वेल्ल्1" => 1,
"वेप्1" => 1,
"वि_अव_षो1" => 1,
"वि_चर्1" => 1,
"विज्2" => 1,
"वि_स्मि1" => 1,
"विट्1" => 1,
"विद्2" => 1,
"वि_द्युत्1" => 1,
"वृ1" => 1,
"वृष्2" => 1,
"वृत्1" => 1,
"वृध्1" => 1,
"व्रण्1" => 1,
"तक्1" => 1,
"तक्2" => 1,
"तम्1" => 1,
"तट्1" => 1,
"तेप्1" => 1,
"थेप्1" => 1,
"तेव्1" => 1,
"तिल्2" => 1,
"तिम्1" => 1,
"तीम्1" => 1,
"तिप्1" => 1,
"थिप्1" => 1,
"तीर1" => 1,
"तीव्1" => 1,
"तृष्1" => 1,
"त्रप्1" => 1,
"त्रस्1" => 1,
"त्रद्1" => 1,
"त्रुट्2" => 1,
"त्सर्1" => 1,
"तूल्1" => 1,
"तुण्1" => 1,
"तुर्1" => 1,
"तुष्1" => 1,
"तूष्1" => 1,
"तुस्1" => 1,
"त्वर्1" => 1,
"त्विष्1" => 1,
"दक्ष्1" => 1,
"दल्1" => 1,
"धन्1" => 1,
"धाव्2" => 1,
"देव्1" => 1,
"दिह्1" => 1,
"दीक्ष्1" => 1,
"दीप्1" => 1,
"धिष्1" => 1,
"दिव्2" => 1,
"दीधी1" => 1,
"धोर्1" => 1,
"दॄ1" => 1,
"दृह्1" => 1,
"दृह्2" => 1,
"दृप्1" => 1,
"दृप्2" => 1,
"धृष्1" => 1,
"द्रा1" => 1,
"द्राड्1" => 1,
"ध्राड्1" => 1,
"द्राघ्1" => 1,
"ध्राघ्1" => 1,
"ध्राक्ष्1" => 1,
"द्रै1" => 1,
"द्रेक्1" => 1,
"ध्रेक्1" => 1,
"ध्रु1" => 1,
"दू1" => 1,
"दुःख1" => 1,
"दुष्1" => 1,
"ध्वाक्ष्1" => 1,
"ध्वंस्1" => 1,
"ध्वन्1" => 1,
"ध्वण्1" => 1,
"ध्वन्2" => 1,
"ध्वन1" => 1,
"ध्वृ1" => 1,
"द्युत्1" => 1,
"यभ्1" => 1,
"यस्1" => 1,
"यत्1" => 1,
"यत्2" => 1,
"येष्1" => 1,
"युछ्1" => 1,
"युत्1" => 1,
"युध्1" => 1
)
;
%GAWYARWA = (
"आङ्_गम्1" => 1,
"आङ्_पद्1" => 1,
"आङ्_ष्ठा1" => 1,
"आङ्_श्रि1" => 1,
"आङ्_विश्1" => 1,
"अनु_पाल्1" => 1,
"अनु_दाव्1" => 1,
"अति_इ1" => 1,
"गम्1" => 1,
"पला_अय्1" => 1,
"परा_अय्1" => 1,
"प्र_आप्1" => 1,
"प्र_चल्1" => 1,
"प्र_ष्ठा1" => 1,
"प्र_विश्1" => 1,
"प्रति_आङ्_गम्1" => 1,
"रम्1" => 1,
"सम्_आङ्_गम्1" => 1,
"सम्_उप_ष्ठा1" => 1,
"उप_आङ्_श्रि1" => 1,
"उत्_यम्1" => 1,
"या1" => 1
)
;
%SLIRAXI = (
"आङ्_रुह्1" => 1,
"अनु_जन्1" => 1,
"अनु_जॄ1" => 1,
"अनु_वस्1" => 1,
"आस्1" => 1,
"जन्1" => 1,
"जॄ1" => 1,
"ष्ठा1" => 1,
"रुह्1" => 1,
"शीङ्1" => 1,
"श्लिष्1" => 1,
"उप_आस्1" => 1,
"उप_ष्ठा1" => 1,
"उप_शीङ्1" => 1,
"उप_श्लिष्1" => 1,
"वस्1" => 1
)
;
%AAXIKARMA = (
"प्र_कृ3" => 1
)
;
$in = <STDIN>; # ignore the first line with headings

while($in = <STDIN>){
 chomp($in);
 $in =~ s/
//;
 @flds = split(/\t/,$in);
 $wrd_no = $flds[0];
 $mo = $flds[5];
 $rel = $flds[6];
 if($mo =~ /\(.*\)/) { 
# If derivational, morph, get the root and the kqw suff
# We need to add similar statments for taddhita
    $mo =~ /\(([^;]+);([^;]+);([^;]+);.*\)/;
    $rt = $1;
    $suff = $2;
    $prayoga = $3;
    if (($prayoga eq "कर्तरि") || ($prayoga  eq "कर्मणि")) 
       { $suff .= "_".$prayoga;}
    if (($suff eq "क्त") && ($AKARMAKA{$rt} || $GAWYARWA{$rt} || $SLIRAXI{$rt} || $AAXIKARMA{$rt}))
    {$suff = "क्तवतु";} 
    $rt_suff = $rt.";".$LAKARA{$suff};
    $mo =~ s/\(.*\)//;
 } else {$rt_suff = "";}

 if($rel =~ /^(विशेषणम्|अभेद)/){
    $mo =~ s/{.*//;
 } else {
   $mo =~ s/{;?/;/;
   $mo =~ s/}//;
   $mo =~ s/;[1-8];/;/;
 }

 if($mo =~ /परस्मैपदी|आत्मनेपदी/) {
    $mo =~ s/;[^;]+;[^;]+;परस्मैपदी;.*//;
    $mo =~ s/;[^;]+;[^;]+;आत्मनेपदी;.*//;
    $mo =~ s/कर्तरि;(.*)/कर्तरि;$LAKARA{$1}/;
    $mo =~ s/कर्मणि;(.*)/कर्मणि;$LAKARA{$1}/;
    $mo =~ s/भावे;(.*)/भावे;$LAKARA{$1}/;
    $mo =~ s/णिजन्त;/णिच्;/;
 }
 if ($rel =~ /अभिहित/) {$rel = ""}
 if($mo =~ /अव्य/){
    #$mo =~ s/अव्य;.*/अव्य/;
    #$mo =~ s/अव्य;//;
    $mo =~ s/;अव्य;.*//;
 }
 if($mo =~ /अस्मद्;सर्वनाम/){
#    $mo =~ s/अस्मद्;सर्वनाम/अस्मद्;सर्वनाम;-/;
    $mo =~ s/अस्मद्;सर्वनाम/अस्मद्;सर्व/;
 }
 if($mo =~ /युष्मद्;सर्वनाम/){
#    $mo =~ s/युष्मद्;सर्वनाम/युष्मद्;सर्वनाम;-/;
    $mo =~ s/युष्मद्;सर्वनाम/युष्मद्;सर्व/;
 }
 if($mo =~ /;सर्वनाम;/){
    $mo =~ s/;सर्वनाम;/;सर्व;/;
 }

 if($rt_suff ne "") {
    $mo =~ s/^([^;])+/$rt_suff/;
 }
 if($mo =~ /_/) {
    $mo =~ s/(.*)_([^_]+)/$1\+$2/; #separate the upasarga and dhatu with + mark
 }

 $mo =~ s/;/,/g;
 $mo =~ s/,अव्य$//;
 if($wrd_no =~ /[0-9]+/) {
  $wrd_no =~ s/^ //;
  $mo =~ s/,/ /g;
  $rel =~ s/,/ /g;
  if ($rel ne "") {
    print $wrd_no," ",$mo," ",$rel,"\n";
  } else { print $wrd_no," ",$mo,"\n";}
  }
}
